# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' IndexedElement Class
#'
#' Indexed elements (IDs) define a unique ID for a collection of multiple metadata elements of the same type within the mzTab-M document, e.g. for sample, assay, study variable etc.
#'
#' @field id 
#' @field elementType 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' MTD	sample[1]-species[1]	[NCBITaxon, NCBITaxon:9606, Homo sapiens, ]
MTD	assay[1]	first assay description
MTD	study_variable[1]	Group B (spike-in 0.74 fmol/uL)

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
IndexedElement <- R6::R6Class(
  'IndexedElement',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    initialize = function(`id`, `elementType`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
    },
    toJSON = function() {
      IndexedElementObject <- list()
      if (!is.null(self$`id`)) {
        IndexedElementObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        IndexedElementObject[['elementType']] <- self$`elementType`
      }

      IndexedElementObject
    },
    fromJSON = function(IndexedElementJson) {
      IndexedElementObject <- jsonlite::fromJSON(IndexedElementJson, simplifyVector = FALSE)
      if (!is.null(IndexedElementObject$`id`)) {
        self$`id` <- IndexedElementObject$`id`
      }
      if (!is.null(IndexedElementObject$`elementType`)) {
        self$`elementType` <- IndexedElementObject$`elementType`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s
        }',
        self$`id`,
        self$`elementType`
      )
    },
    fromJSONString = function(IndexedElementJson) {
      IndexedElementObject <- jsonlite::fromJSON(IndexedElementJson, simplifyVector = FALSE)
      self$`id` <- IndexedElementObject$`id`
      self$`elementType` <- IndexedElementObject$`elementType`
    }
  )
)
