# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Sample Class
#'
#' Specification of sample. (empty) name: A name for each sample to serve as a list of the samples that MUST be reported in the following tables. Samples MUST be reported if a statistical design is being captured (i.e. bio or tech replicates). If the type of replicates are not known, samples SHOULD NOT be reported.  species: The respective species of the samples analysed. For more complex cases, such as metagenomics, optional columns and userParams should be used.  tissue: The respective tissue(s) of the sample.  cell_type: The respective cell type(s) of the sample.  disease: The respective disease(s) of the sample.  description: A human readable description of the sample.  custom: Custom parameters describing the sample&#39;s additional properties. Dates MUST be provided in ISO-8601 format. 
#'
#' @field id 
#' @field elementType 
#' @field name 
#' @field custom 
#' @field species 
#' @field tissue 
#' @field cell_type 
#' @field disease 
#' @field description 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' COM	Experiment where all samples consisted of the same two species
MTD	sample[1]	individual number 1
MTD	sample[1]-species[1]	[NCBITaxon, NCBITaxon:9606, Homo sapiens, ]
MTD	sample[1]-tissue[1]	[BTO, BTO:0000759, liver, ]
MTD	sample[1]-cell_type[1]	[CL, CL:0000182, hepatocyte, ]
MTD	sample[1]-disease[1]	[DOID, DOID:684, hepatocellular carcinoma, ]
MTD	sample[1]-disease[2]	[DOID, DOID:9451, alcoholic fatty liver, ]
MTD	sample[1]-description	Hepatocellular carcinoma samples.
MTD	sample[1]-custom[1]	[,,Extraction date, 2011-12-21]
MTD	sample[1]-custom[2]	[,,Extraction reason, liver biopsy]
MTD	sample[2]	individual number 2
MTD	sample[2]-species[1]	[NCBITaxon, NCBITaxon:9606, Homo sapiens, ]
MTD	sample[2]-tissue[1]	[BTO, BTO:0000759, liver, ]
MTD	sample[2]-cell_type[1]	[CL, CL:0000182, hepatocyte, ]
MTD	sample[2]-description	Healthy control samples.

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Sample <- R6::R6Class(
  'Sample',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `name` = NULL,
    `custom` = NULL,
    `species` = NULL,
    `tissue` = NULL,
    `cell_type` = NULL,
    `disease` = NULL,
    `description` = NULL,
    initialize = function(`id`, `elementType`, `name`, `custom`, `species`, `tissue`, `cell_type`, `disease`, `description`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!missing(`custom`)) {
        stopifnot(is.list(`custom`), length(`custom`) != 0)
        lapply(`custom`, function(x) stopifnot(R6::is.R6(x)))
        self$`custom` <- `custom`
      }
      if (!missing(`species`)) {
        stopifnot(is.list(`species`), length(`species`) != 0)
        lapply(`species`, function(x) stopifnot(R6::is.R6(x)))
        self$`species` <- `species`
      }
      if (!missing(`tissue`)) {
        stopifnot(is.list(`tissue`), length(`tissue`) != 0)
        lapply(`tissue`, function(x) stopifnot(R6::is.R6(x)))
        self$`tissue` <- `tissue`
      }
      if (!missing(`cell_type`)) {
        stopifnot(is.list(`cell_type`), length(`cell_type`) != 0)
        lapply(`cell_type`, function(x) stopifnot(R6::is.R6(x)))
        self$`cell_type` <- `cell_type`
      }
      if (!missing(`disease`)) {
        stopifnot(is.list(`disease`), length(`disease`) != 0)
        lapply(`disease`, function(x) stopifnot(R6::is.R6(x)))
        self$`disease` <- `disease`
      }
      if (!missing(`description`)) {
        stopifnot(is.character(`description`), length(`description`) == 1)
        self$`description` <- `description`
      }
    },
    toJSON = function() {
      SampleObject <- list()
      if (!is.null(self$`id`)) {
        SampleObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        SampleObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`name`)) {
        SampleObject[['name']] <- self$`name`
      }
      if (!is.null(self$`custom`)) {
        SampleObject[['custom']] <- lapply(self$`custom`, function(x) x$toJSON())
      }
      if (!is.null(self$`species`)) {
        SampleObject[['species']] <- lapply(self$`species`, function(x) x$toJSON())
      }
      if (!is.null(self$`tissue`)) {
        SampleObject[['tissue']] <- lapply(self$`tissue`, function(x) x$toJSON())
      }
      if (!is.null(self$`cell_type`)) {
        SampleObject[['cell_type']] <- lapply(self$`cell_type`, function(x) x$toJSON())
      }
      if (!is.null(self$`disease`)) {
        SampleObject[['disease']] <- lapply(self$`disease`, function(x) x$toJSON())
      }
      if (!is.null(self$`description`)) {
        SampleObject[['description']] <- self$`description`
      }

      SampleObject
    },
    fromJSON = function(SampleJson) {
      SampleObject <- jsonlite::fromJSON(SampleJson, simplifyVector = FALSE)
      if (!is.null(SampleObject$`id`)) {
        self$`id` <- SampleObject$`id`
      }
      if (!is.null(SampleObject$`elementType`)) {
        self$`elementType` <- SampleObject$`elementType`
      }
      if (!is.null(SampleObject$`name`)) {
        self$`name` <- SampleObject$`name`
      }
      if (!is.null(SampleObject$`custom`)) {
        self$`custom` <- lapply(SampleObject$`custom`, function(x) {
          `customObject` <- Parameter$new()
          `customObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `customObject`
        })
      }
      if (!is.null(SampleObject$`species`)) {
        self$`species` <- lapply(SampleObject$`species`, function(x) {
          `speciesObject` <- Parameter$new()
          `speciesObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `speciesObject`
        })
      }
      if (!is.null(SampleObject$`tissue`)) {
        self$`tissue` <- lapply(SampleObject$`tissue`, function(x) {
          `tissueObject` <- Parameter$new()
          `tissueObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `tissueObject`
        })
      }
      if (!is.null(SampleObject$`cell_type`)) {
        self$`cell_type` <- lapply(SampleObject$`cell_type`, function(x) {
          `cell_typeObject` <- Parameter$new()
          `cell_typeObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `cell_typeObject`
        })
      }
      if (!is.null(SampleObject$`disease`)) {
        self$`disease` <- lapply(SampleObject$`disease`, function(x) {
          `diseaseObject` <- Parameter$new()
          `diseaseObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `diseaseObject`
        })
      }
      if (!is.null(SampleObject$`description`)) {
        self$`description` <- SampleObject$`description`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "name": %s,
           "custom": [%s],
           "species": [%s],
           "tissue": [%s],
           "cell_type": [%s],
           "disease": [%s],
           "description": %s
        }',
        self$`id`,
        self$`elementType`,
        self$`name`,
        lapply(self$`custom`, function(x) paste(x$toJSON(), sep=",")),
        lapply(self$`species`, function(x) paste(x$toJSON(), sep=",")),
        lapply(self$`tissue`, function(x) paste(x$toJSON(), sep=",")),
        lapply(self$`cell_type`, function(x) paste(x$toJSON(), sep=",")),
        lapply(self$`disease`, function(x) paste(x$toJSON(), sep=",")),
        self$`description`
      )
    },
    fromJSONString = function(SampleJson) {
      SampleObject <- jsonlite::fromJSON(SampleJson, simplifyVector = FALSE)
      self$`id` <- SampleObject$`id`
      self$`elementType` <- SampleObject$`elementType`
      self$`name` <- SampleObject$`name`
      self$`custom` <- lapply(SampleObject$`custom`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`species` <- lapply(SampleObject$`species`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`tissue` <- lapply(SampleObject$`tissue`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`cell_type` <- lapply(SampleObject$`cell_type`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`disease` <- lapply(SampleObject$`disease`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      self$`description` <- SampleObject$`description`
    }
  )
)
