# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Uri Class
#'
#' A URI pointing to the file’s source data (e.g., a MetaboLights records) or an external file with more details about the study design.
#'
#' @field id 
#' @field elementType 
#' @field value 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' MTD	uri[1]	https://www.ebi.ac.uk/metabolights/MTBLS517
…
MTD	external_study_uri[1]	https://www.ebi.ac.uk/metabolights/MTBLS517/files/i_Investigation.txt

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Uri <- R6::R6Class(
  'Uri',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `value` = NULL,
    initialize = function(`id`, `elementType`, `value`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`value`)) {
        stopifnot(is.character(`value`), length(`value`) == 1)
        self$`value` <- `value`
      }
    },
    toJSON = function() {
      UriObject <- list()
      if (!is.null(self$`id`)) {
        UriObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        UriObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`value`)) {
        UriObject[['value']] <- self$`value`
      }

      UriObject
    },
    fromJSON = function(UriJson) {
      UriObject <- jsonlite::fromJSON(UriJson, simplifyVector = FALSE)
      if (!is.null(UriObject$`id`)) {
        self$`id` <- UriObject$`id`
      }
      if (!is.null(UriObject$`elementType`)) {
        self$`elementType` <- UriObject$`elementType`
      }
      if (!is.null(UriObject$`value`)) {
        self$`value` <- UriObject$`value`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "value": %s
        }',
        self$`id`,
        self$`elementType`,
        self$`value`
      )
    },
    fromJSONString = function(UriJson) {
      UriObject <- jsonlite::fromJSON(UriJson, simplifyVector = FALSE)
      self$`id` <- UriObject$`id`
      self$`elementType` <- UriObject$`elementType`
      self$`value` <- UriObject$`value`
    }
  )
)
