# mzTab-M reference implementation and validation API.
# 
# This is the mzTab-M reference implementation and validation API service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Database Class
#'
#' Specification of databases. (empty): The description of databases used. For cases, where a known database has not been used for identification, a userParam SHOULD be inserted to describe any identification performed e.g. de novo. If no identification has been performed at all then \&quot;no database\&quot; should be inserted followed by null. prefix: The prefix used in the “identifier” column of data tables. For the “no database” case \&quot;null\&quot; must be used. version: The database version is mandatory where identification has been performed. This may be a formal version number e.g. “1.4.1”, a date of access “2016-10-27” (ISO-8601 format) or “Unknown” if there is no suitable version that can be annotated. uri: The URI to the database. For the “no database” case, \&quot;null\&quot; must be reported. 
#'
#' @field id 
#' @field elementType 
#' @field param 
#' @field prefix 
#' @field version 
#' @field uri 
#'
#' mzTab-M specification example(s)
#' \preformatted{
#' MTD	database[1]	[MIRIAM, MIR:00100079, HMDB, ]
MTD	database[1]-prefix	hmdb
MTD	database[1]-version	3.6
MTD	database[1]-uri	http://www.hmdb.ca/
MTD	database[2]	[,, "de novo", ]
MTD	database[2]-prefix	dn
MTD	database[2]-version	Unknown
MTD	database[2]-uri	null
MTD	database[3]	[,, "no database", null ]
MTD	database[3]-prefix	null
MTD	database[3]-version	Unknown
MTD	database[3]-uri	null

#' }
#' 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Database <- R6::R6Class(
  'Database',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `param` = NULL,
    `prefix` = NULL,
    `version` = NULL,
    `uri` = NULL,
    initialize = function(`id`, `elementType`, `param`, `prefix`, `version`, `uri`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`param`)) {
        stopifnot(R6::is.R6(`param`))
        self$`param` <- `param`
      }
      if (!missing(`prefix`)) {
        stopifnot(is.character(`prefix`), length(`prefix`) == 1)
        self$`prefix` <- `prefix`
      }
      if (!missing(`version`)) {
        stopifnot(is.character(`version`), length(`version`) == 1)
        self$`version` <- `version`
      }
      if (!missing(`uri`)) {
        stopifnot(is.character(`uri`), length(`uri`) == 1)
        self$`uri` <- `uri`
      }
    },
    toJSON = function() {
      DatabaseObject <- list()
      if (!is.null(self$`id`)) {
        DatabaseObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        DatabaseObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`param`)) {
        DatabaseObject[['param']] <- self$`param`$toJSON()
      }
      if (!is.null(self$`prefix`)) {
        DatabaseObject[['prefix']] <- self$`prefix`
      }
      if (!is.null(self$`version`)) {
        DatabaseObject[['version']] <- self$`version`
      }
      if (!is.null(self$`uri`)) {
        DatabaseObject[['uri']] <- self$`uri`
      }

      DatabaseObject
    },
    fromJSON = function(DatabaseJson) {
      DatabaseObject <- jsonlite::fromJSON(DatabaseJson, simplifyVector = FALSE)
      if (!is.null(DatabaseObject$`id`)) {
        self$`id` <- DatabaseObject$`id`
      }
      if (!is.null(DatabaseObject$`elementType`)) {
        self$`elementType` <- DatabaseObject$`elementType`
      }
      if (!is.null(DatabaseObject$`param`)) {
        `paramObject` <- Parameter$new()
        `paramObject`$fromJSON(jsonlite::toJSON(DatabaseObject$param, auto_unbox = TRUE))
        self$`param` <- `paramObject`
      }
      if (!is.null(DatabaseObject$`prefix`)) {
        self$`prefix` <- DatabaseObject$`prefix`
      }
      if (!is.null(DatabaseObject$`version`)) {
        self$`version` <- DatabaseObject$`version`
      }
      if (!is.null(DatabaseObject$`uri`)) {
        self$`uri` <- DatabaseObject$`uri`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "param": %s,
           "prefix": %s,
           "version": %s,
           "uri": %s
        }',
        self$`id`,
        self$`elementType`,
        self$`param`$toJSON(),
        self$`prefix`,
        self$`version`,
        self$`uri`
      )
    },
    fromJSONString = function(DatabaseJson) {
      DatabaseObject <- jsonlite::fromJSON(DatabaseJson, simplifyVector = FALSE)
      self$`id` <- DatabaseObject$`id`
      self$`elementType` <- DatabaseObject$`elementType`
      ParameterObject <- Parameter$new()
      self$`param` <- ParameterObject$fromJSON(jsonlite::toJSON(DatabaseObject$param, auto_unbox = TRUE))
      self$`prefix` <- DatabaseObject$`prefix`
      self$`version` <- DatabaseObject$`version`
      self$`uri` <- DatabaseObject$`uri`
    }
  )
)
